// CodePage.cpp cCve[Vt@C
#include "CodePage.h"
#include <algorithm>                        // std::copy()


// UTFBOM
typedef struct tagUTF_BOM
{
	BYTE bom[4];                            // BOMp^[
	UINT bom_size;                          // BOMTCYioCgj
	UINT codepage;                          // R[hy[W
} UTF_BOM;

// eGR[h̏
const UTF_BOM g_utf_bom_array[] =
{
	{{0xef, 0xbb, 0xbf}, 3, CODEPAGE_UTF8   },  // UTF-8
	{{0xff, 0xfe      }, 2, CODEPAGE_UTF16LE},  // UTF-16LE
	{{0xfe, 0xff      }, 2, CODEPAGE_UTF16BE},  // UTF-16BE
};


// w肳ꂽR[hy[WBOM擾
BOOL CodePage_GetBOM(const UINT uCodePage, BYTE rBom[], UINT &rBomSize)
{
	for(int i = 0; i < countof(g_utf_bom_array); i++)
	{
		const UTF_BOM &utf_bom = g_utf_bom_array[i];
		if(uCodePage == utf_bom.codepage)
		{
			rBomSize = utf_bom.bom_size;
			std::copy(utf_bom.bom, utf_bom.bom + utf_bom.bom_size, rBom);
			return TRUE;
		}
	}
	return FALSE;
}


// w肳ꂽR[hy[WBOM݂邩`FbN
BOOL CodePage_ExistsBOM(LPCSTR pSrcStr, const SIZE_T cSrcSize, UINT &rOffset, const UINT uCodePage)
{
	rOffset = 0;
	for(int i = 0; i < countof(g_utf_bom_array); i++)
	{
		const UTF_BOM &utf_bom = g_utf_bom_array[i];
		if(utf_bom.codepage != uCodePage)
		{
			continue;
		}

		const UINT bom_size = utf_bom.bom_size;
		if(cSrcSize >= bom_size && memcmp(pSrcStr, utf_bom.bom, bom_size) == 0)
		{
			// BOMTRUEԂ
			rOffset = bom_size;
			return TRUE;
		}
	}
	// BOMȂFALSEԂ
	return FALSE;
}
